require 'http-cookie'

module SoarAuthenticationToken
  class CookieProvider
    def initialize(configuration)
      @configuration = configuration
      validate_configuration
    end

    def fetch(request)
      return false unless request.env.has_key?('HTTP_COOKIE')
      return false unless request.cookies.has_key?(@configuration['cookie_name'])

      request.cookies[@configuration['cookie_name']]
    end

    def validate_configuration
      raise "'cookie_name' must be configured" unless @configuration['cookie_name']
    end
  end
end
