module SoarAuthenticationToken
  class TokenValidator
    def initialize(configuration)
      @configuration = configuration
      validate_configuration
      instantiate_provider
    end

    def inject_store_provider(store_provider)
      @provider.inject_store_provider(store_provider)
    end

    def validate(authentication_token:, request_information: {}, flow_identifier: nil)
      @provider.validate(authentication_token: authentication_token,
                         request_information:  request_information,
                         flow_identifier:      flow_identifier)
    end

    private

    def instantiate_provider
      @provider = Object::const_get(@configuration['provider']).new(@configuration)
    end

    def validate_configuration
      raise "'provider' must be configured" unless @configuration['provider']
    end
  end
end
